function C=binaryop_init(A,B,fun)
% function C=binaryop(A,B,fun)
%   element by element generic function
%   fun is either @times, @power, @rdivide or @ldivide
  assert(sum(strcmp(func2str(fun),{'times','power','rdivide','ldivide','plus','minus'}))==1)
  isA3D=fc_linalg3D.is3Darray(A);
  isB3D=fc_linalg3D.is3Darray(B);
  assert( isA3D || isB3D , 'One of the two parameters must be a 3D-array')
%  I comment the following for benchmark testing
%    if (isA3D && isB3D) % Both 3D-arrays with same size
%      assert( any(size(A)==size(B)) )
%      C=fun(A,B);
%      return
%    end
%    if isscalar(A) || isscalar(B) % One is a scalar
%      C=fun(A,B);
%      return
%    end
  C=[];
end
