function [Out,bDs]=set_det(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('d',3,@isscalar);
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.parse(varargin{:});
  R=p.Results;
  Fprintf=R.fprintf;
  d=R.d;
  %mattype=R.mattype;
  A=fc_linalg3D.random.randn(N,d,d);
  
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  if verbose
    Fprintf('# 1st parameter is :\n');
    Fprintf('# -> 3D-array with (N,d,d)=(%d,%d,%d),  size=[%s]\n',N,d,d,num2str(size(A)))
  end
  
  bDs(1)=fc_bench.bdata('N',N,'%d',10);
  Out={A};
end
